{
// .x view-BEwt.C
//
// BE weight and total pion multiplicity
// FITTING counterterms!!!
//
gROOT->Reset();
//------------------------------------------------------------------------
gStyle->SetFrameLineWidth(3);
gStyle->SetStatW(0.35);
gStyle->SetStatH(0.25);
gStyle->SetStatX(0.99);
gStyle->SetStatY(0.99);
gStyle->SetStatColor(0);
gStyle->SetTitleColor(0);
gStyle->SetTitleW(0.60);
gStyle->SetTitleH(0.09);
gStyle->SetTitleX(0.03);
gStyle->SetTitleY(1.00);
//
TPaveText labelXn( .45,.00,.55,.08, "NDC");
labelXn.AddText("n");
labelXn.SetFillColor(10);
labelXn.SetBorderSize(0);
//
TPaveText labelYn( .00,.55,.09, .55+.08, "NDC");
labelYn.AddText("n");
labelYn.SetFillColor(10);
labelYn.SetBorderSize(0);
//
TPaveText labelWT( .35,.00,.55,.08, "NDC");
labelWT.AddText("WT");
labelWT.SetFillColor(10);
labelWT.SetBorderSize(0);
//------------------------------------------------------------------------
cBEwt = new TCanvas("cBEwt","Multiplicities and weights",800,800);
//------------------------------------------------------------------------
int nevmax = 150000;
//------------------------------------------------------------------------
// 172GeV 2W   Production
//[[[[[[[
TFile f1("../run/172GeV.4J/rmain.root","READ");
//Text_t *WT=    "wt*exp(-np*log(1.07))/1.022";      // mult. distr. Aleph!!!
//Text_t *WH=    "wt*exp(-np*log(1.07))/1.022>>h_wt";// wt distr.    Aleph!!!
//Text_t *XY= "np:(wt*exp(-np*log(1.07)))/1.022";    // scatergram   Aleph!!!
//]]]]]]]
//TFile f1("../run/172GeV.4J/rmain.root.160k","READ");
//Text_t *WT=    "wt*exp(-np*log(0.999))/1.022";        // mult. distr.
//Text_t *WH=    "wt*exp(-np*log(0.999))/1.022>>h_wt";  // wt distr.
//Text_t *XY= "np:(wt*exp(-np*log(1.0)))/1.022";        // scatergram
Text_t *WT=    "wt2*exp(-np*log(0.999))/1.022*1.165";        //!!!wt2
Text_t *WH=    "wt2*exp(-np*log(0.999))/1.022*1.165>>h_wt";  //!!!wt2
Text_t *XY= "np:(wt2*exp(-np*log(1.0)))/1.022*1.165";        //!!!wt2
//------------------------------------------------------------------------
// 172GeV 2W   FITTING lambda
//TFile f1("../run/172GeV.4J.mini/rmain.root.40k");
//Text_t *WT=    "(wt*exp(-np*log(1.0675)))/0.1751";
//Text_t *WH=    "(wt*exp(-np*log(1.0675)))/0.1751>>h_wt";
//Text_t *XY= "np:(wt*exp(-np*log(1.0675)))/0.1751";
//------------------------------------------------------------------------
// 172GeV 1W,  FITTING lambda
//TFile f1("../run/172GeV.2J.mini/rmain.root.40k");            //looks OK!
//Text_t *WT=    "(wt*exp(-np*log(1.051)))/0.4387/1.165";      //only additional
//Text_t *WH=    "(wt*exp(-np*log(1.051)))/0.4387/1.165>>h_wt";//const=1.165
//Text_t *XY= "np:(wt*exp(-np*log(1.051)))/0.4387/1.165";      //normalization
//------------------------------------------------------------------------
//------------------------------------------------------------------------
// 200GeV 2W,  PRODUCTION
//TFile f1("../run/200GeV.4J/rmain.root.40k");
//Text_t *WT=    "(wt*exp(-np*log(1.000+0.001)))/0.926";
//Text_t *WH=    "(wt*exp(-np*log(1.000+0.001)))/0.926>>h_wt";
//Text_t *XY= "np:(wt*exp(-np*log(1.000+0.001)))/0.926";
//Text_t *WT=    "(wt2*exp(-np*log(1.000-0.001)))/1.0*1.291";      //!!!wt2
//Text_t *WH=    "(wt2*exp(-np*log(1.000-0.001)))/1.0*1.291>>h_wt";//!!!wt2
//Text_t *XY= "np:(wt2*exp(-np*log(1.000-0.001)))/1.0*1.291";      //!!!wt2
//------------------------------------------------------------------------
// 200GeV 2W,  FITTING lambda
//TFile f1("../run/200GeV.4J.mini/rmain.root.4k");
//Text_t *WT=    "(wt*exp(-np*log(1.0617)))/0.2095/1.895";      //???
//Text_t *WH=    "(wt*exp(-np*log(1.0617)))/0.2095/1.895>>h_wt";//???
//Text_t *XY= "np:(wt*exp(-np*log(1.0617)))/0.2095/1.895";      //???
//------------------------------------------------------------------------
// 200GeV 1W,  FITTING lambda
//TFile f1("../run/200GeV.2J.mini/rmain.root.40k");             // OK
//Text_t *WT=    "(wt*exp(-np*log(1.0495)))/0.3986/1.322";      // <n> to big
//Text_t *WH=    "(wt*exp(-np*log(1.0495)))/0.3986/1.322>>h_wt";// 0.5 only
//Text_t *XY= "np:(wt*exp(-np*log(1.0495)))/0.3986/1.322";      //
//Text_t *WT=    "(wt*exp(-np*log(1.0495+0.001)))/0.3986/1.291";      //!!!
//Text_t *WH=    "(wt*exp(-np*log(1.0495+0.001)))/0.3986/1.291>>h_wt";//!!!
//Text_t *XY= "np:(wt*exp(-np*log(1.0495+0.001)))/0.3986/1.191";      //!!!
//------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
//TFile f1("rmain.root");
//------------------------------------------------------------------------
//    total multiplicity wt=1
//------------------------------------------------------------------------
cBEwt.cd();
cBEwt.SetFillColor(5);
TPad pad1("pad1","This is pad1", .00,.50,.50,1.00, 5, 0, 0);
pad1.Draw();
pad1.cd();
pad1.SetFillColor(10);
h_ntot = new TH1F("h_ntot","n: all pions", 100,0,100);
h_ntot->SetLabelSize(.06,"X");
jtuple.Draw("np>>h_ntot","","",nevmax);  // total multiplicity wt=1
//TText t1(0.50,0.80,"nnnnnn");//!!!!!!
//t1.SetTextAlign(11);         //!!!!!! here I get text into wrong place!!!
//t1.SetTextSize(.10);         //!!!!!!
//t1.Draw();                   //!!!!!!
labelXn.Draw();
cBEwt.Update();
//------------------------------------------------------------------------
//   total multiplicity with counterterm
//------------------------------------------------------------------------
cBEwt.cd();
TPad pad3("pad3","This is pad3", .00,.00, .50,.50, 5, 0, 0);
pad3.Draw();
pad3.cd();
pad3.SetFillColor(10);
h_ntwt = new TH1F("h_ntwt","n: all pions; WTed", 100,0,100);
h_ntwt->SetLabelSize(.06,"X");
//
jtuple.Draw("np>>h_ntwt",WT,"",nevmax);
//h_ntwt.Divide(h_ntot);         // to see the ratio...
h_ntwt.Draw();
//////hst_BEwt->Draw();
labelXn.Draw();
cBEwt.Update();
//------------------------------------------------------------------------
//   weight distribution
//------------------------------------------------------------------------
cBEwt.cd();
TPad pad2("pad2","This is pad2", .50,.50, 1.00,1.00, 5, 0, 0);
pad2.Draw();
pad2.cd();
pad2.SetFillColor(10);
h_wt = new TH1F("h_wt","B.E. weight WT", 50,0,10);
h_wt->SetLabelSize(.06,"X");
jtuple.Draw(WH,"","goff",nevmax);  // weight distrib
h_wt.Draw();
labelWT.Draw();
cBEwt.Update();
//------------------------------------------------------------------------
//   Scaterplot multiplicity X weight
//------------------------------------------------------------------------
cBEwt.cd();
TPad pad4("pad4","This is pad4", .50,.00,1.00,.50, 5, 0, 0);
pad4.Draw();
pad4.cd();
pad4.SetFillColor(10);
//
scat_res = new TH2F("scat_res","WT vs. n",100,0.,10., 100,.0,100.);
scat_res->SetLabelSize(.06,"X");
scat_res.Draw();
cBEwt.Update();
jtuple.Draw(XY,"","same",9000);
//
labelYn.Draw();
labelWT.Draw();
//
cBEwt.Update();
cBEwt.cd();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
}
//******************************** older version
// multiplicity distribution divided by lambda**n factor
//TH1F *f_ntot = new TH1F("f_ntot"," damping factor",100,0,100);
//Stat_t z[200];
//double lambda;
//lambda = 1.058; // 1W Range 0.20, ifun=2
//for (int j=0; j<200 ;j++) z[j] = exp(j*log(lambda));
//f_ntot.SetContent(z);
//jtuple.Draw("np>>h_ntwt","wt","");  // total multiplicity wt=1
//h_ntwt.Divide(f_ntot);
//pad3.SetLogy();
//******************************** end older version
