{
// .x view-jet2.C
// plots of MINIMUM ENERGY and MINIMUM ANGLE
//
gROOT->Reset();
cJet2 = new TCanvas("cJet2","The Ntuple canvas",800,800);
gStyle->SetOptStat(0);
gStyle->SetTitleColor(0);
gStyle->SetTitleW(0.60);
gStyle->SetTitleH(0.09);
gStyle->SetTitleX(0.03);
gStyle->SetTitleY(1.00);
//------------------------------------------------------------------------
//------------------------------------------------------------------------
TPaveLabel labelRad( .65, .01, .65+.15, .01+.08, "[rad]","NDC");
labelRad->SetBorderSize(0);
labelRad->SetFillColor(0);
TPaveLabel labelGeV( .70, .01, .70+.15, .01+.08, "[GeV]","NDC");
labelGeV->SetBorderSize(0);
labelGeV->SetFillColor(0);
//------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
//------------------------------------------------------------------------
// 172GeV 2W test run,  Range=0.20,ifun=2
//TFile f1("../run/172GeV.4J.mini/rmain.root");
//Text_t *WT    "(wt*exp(-np*log(1.070)))/0.1550";
//------------------------------------------------------------------------
// 172GeV 2W production
TFile f1("../run/172GeV.4J/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root.160k");
//TFile f1("../run/172GeV.4J/rmain.root");
//Text_t *WT    "(wt*exp(-np*log(1.00)))/1.0";
//
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cJet2.cd();
TPad pad1("pad1","This is pad1", .00,.50, 0.50, 1.00, 0,0,0);
pad1.SetFillColor(0);
pad1.Draw();
pad1.cd();
//###################
TH1F *hst_min_jene =new TH1F("hst_min_jene" ,"(a) JET min. ENE, nj=4",100,0,50);
hst_min_jene->SetLabelSize(0.05);
jtuple.Draw("jen >>hst_min_jene","(nj==4)","goff");
//###################
hst_min_jene.Draw();
labelGeV->Draw();
//
//hst_jene.Draw();
cJet2.Update();
//
//------------------------------------------------------------------------
cJet2.cd();
TPad pad2("pad2","This is pad2", .50,.50, 1.00,1.00 ,0,0,0);
pad2.SetFillColor(0);
pad2.Draw();
pad2.cd();
//###################
TH1F *hst_min_pene =new TH1F("hst_min_pene" ,"(b) QUARK min. ENE",100,0,50);
hst_min_pene->SetLabelSize(0.05);
jtuple.Draw("pen >>hst_min_pene","","goff");
//###################
hst_min_pene.Draw();
labelGeV->Draw();
//
//hst_pene.Draw();
cJet2.Update();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cJet2.cd();
TPad pad3("pad3","This is pad3", .00,.00, 0.50,0.50 ,0,0,0);
pad3.SetFillColor(10);
pad3.Draw();
pad3.cd();
//###################
TH1F *hst_min_jang = new TH1F("hst_min_jang" ,"(c) JET min. ANGLE, nj=4",100,0,3.1415);
hst_min_jang->SetLabelSize(0.06);
jtuple.Draw("jan >>hst_min_jang","(nj==4)","goff");
//###################
hst_min_jang.Draw();
labelRad->Draw();
cJet2.Update();
//
//------------------------------------------------------------------------
cJet2.cd();
TPad pad4("pad4","This is pad4", .50,.00,1.00,0.50 ,0,0,0);
pad4.SetFillColor(0);
pad4.Draw();
pad4.cd();
//###################
TH1F *hst_min_pang = new TH1F("hst_min_pang" ,"(d) QUARK min. ANGLE",100,0,3.1415);
hst_min_pang->SetLabelSize(0.06);
jtuple.Draw("pan >>hst_min_pang","","goff");
//###################
hst_min_pang.Draw();
labelRad->Draw();
cJet2.Update();
//------------------------------------------------------------------------
cJet2.cd();
//------------------------------------------------------------------------
}
