//----------------------------------------------------------------------------
// .x view-jet3.C
// 2-dim scattergrams
//
//----------------------------------------------------------------------------
{
gROOT->Reset();
gStyle->SetOptStat(0);
gStyle->SetTitleColor(0);
gStyle->SetTitleW(0.94);
gStyle->SetTitleH(0.09);
gStyle->SetTitleX(0.03);
gStyle->SetTitleY(1.00);
cJet3 = new TCanvas("cJet3","The Ntuple canvas",800,800);
//------------------------------------------------------------------------
// Connect ROOT histogram/ntuple demonstration file
TFile f1("../run/172GeV.4J/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root.160k");
//TFile f1("../run/172GeV.4J.mini/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root");
//------------------------------------------------------------------------
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(0);
float Mmin =  25.0;
float Mmax = 120.0;
int   Nb   =  95;
//------------------------------------------------------------------------
cJet3.cd();
TPad pad1("pad1","This is pad1", .00,.50, .50, 1.00);
pad1.Draw();
pad1.cd();
pad1.SetFillColor(10);
scat_all = new TH2F("scat_all","Quarks: M?i! vs. M?j!"
		    ,Nb,Mmin,Mmax,Nb,Mmin,Mmax);
scat_all->SetLabelSize(0.05,"X");
scat_all->SetLabelSize(0.05,"Y");
scat_all.Draw();
cJet3.Update();
jtuple.Draw("m0:m1","","same",7000);
jtuple.Draw("m2:m3","","same",7000);
jtuple.Draw("m4:m5","","same",7000);
//m_01.DrawCopy("lego");
cJet3.Update();
//
//------------------------------------------------------------------------
cJet3.cd();
TPad pad2("pad2","This is pad2", .50,.50, 1.00 , 1.00);
pad2.Draw();
pad2.cd();
pad2.SetFillColor(10);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
scat_all_cut= new TH2F("scat_all_cut",
		       "Quarks: M?i! vs. M?j!; |M?i!-M?j!|<5GeV",
		       Nb,Mmin,Mmax,Nb,Mmin,Mmax);
scat_all_cut->SetLabelSize(0.05,"X");
scat_all_cut->SetLabelSize(0.05,"Y");
scat_all_cut.Draw();cJet3.Update();
jtuple.Draw("m0:m1","abs(m0-m1)<5.0","same",7000);
jtuple.Draw("m2:m3","abs(m2-m3)<5.0","same",7000);
jtuple.Draw("m4:m5","abs(m4-m5)<5.0","same",7000);
//------------------------------------------------------------------------
cJet3.cd();
cJet3.SetFillColor(5);
TPad pad3("pad3","This is pad3", .00,.00, .50,.50);
pad3.Draw();
pad3.cd();
pad3.SetFillColor(10);
scat_res = new TH2F("scat_res","Jets: M?i! vs. M?j!",
		    Nb,Mmin,Mmax,Nb,Mmin,Mmax);
scat_res->SetLabelSize(0.05,"X");
scat_res->SetLabelSize(0.05,"Y");
scat_res.Draw();cJet3.Update();
jtuple.Draw("x0:x1","","same",3500);
jtuple.Draw("x2:x3","","same",3500);
jtuple.Draw("x4:x5","","same",3500);
jtuple.Draw("x1:x0","","same",3500);
jtuple.Draw("x3:x2","","same",3500);
jtuple.Draw("x5:x4","","same",3500);
cJet3.Update();
//------------------------------------------------------------------------
cJet3.cd();
TPad pad4("pad4","This is pad4", .50,.00, 1.00,.50);
pad4.Draw();
pad4.cd();
pad4.SetFillColor(10);
scat_phs = new TH2F("scat_phs","Jets: M?i! vs. M?j!; |M?i!-M?j!|<10GeV",
		    Nb,Mmin,Mmax,Nb,Mmin,Mmax);
scat_phs->SetLabelSize(0.05,"X");
scat_phs->SetLabelSize(0.05,"Y");
scat_phs.Draw();cJet3.Update();
jtuple.Draw("x0:x1","abs(x0-x1)<10.0","same",3500);
jtuple.Draw("x2:x3","abs(x2-x3)<10.0","same",3500);
jtuple.Draw("x4:x5","abs(x4-x5)<10.0","same",3500);
jtuple.Draw("x0:x1","abs(x1-x0)<10.0","same",3500);
jtuple.Draw("x2:x3","abs(x3-x2)<10.0","same",3500);
jtuple.Draw("x4:x5","abs(x5-x4)<10.0","same",3500);
cJet3.Update();
//
cJet3.cd();
}
