{
// 1-dim exercises
// In this exercise we project on single mass, we take m0 only
// .x view-par2.C
//
gROOT.Reset();
cPar2 = new TCanvas("cPar2","The Ntuple canvas",800,800);
//
// Connect ROOT histogram/ntuple demonstration file
TFile f1("../172GeV.4J.mini/rmain.root");
//TFile f1("../172GeV.4J/rmain.root.40k");
//TFile f1("../172GeV.4J/rmain.root");
//
//------------------------------------------------------------------------
cPar2.cd();
cPar2.SetFillColor(5);
TPad pad1("pad1","This is pad1", .01,.50, (.01+.48),(.50+.48), 15);
pad1.Draw();
pad1.cd();
pad1.SetFillColor(10);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
mass_res = new TH1F("mass_res","mass resonant ",100, 70,90);
jtuple.Draw("m0>>mass_res","","");
cPar2.Update();
//
//------------------------------------------------------------------------
cPar2.cd();
TPad pad2("pad2","This is pad2", .50,.50, (.50+.48),(.50+.48), 15);
pad2.Draw();
pad2.cd();
pad1.SetFillColor(10);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
pad2.SetFillColor(10);
mass_all = new TH1F("mass_all","mass dist all ", 100,70,90);
jtuple.Draw( "m0>>mass_all","","goff");
jtuple.Draw("m2>>+mass_all","","goff");
jtuple.Draw("m4>>+mass_all","","goff");
mass_all.Draw(0);cPar2.Update();
//
mass_combi = new TH1F("mass_combi","mass combinatorial ", 100,70,90);
mass_combi.Add(mass_all,mass_res, 1. , -1.);
mass_combi.Draw("same");
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cPar2.cd();
TPad pad3("pad3","This is pad3", .01,.01, (.01+.48),(.01+.48), 15);
pad3.Draw();
pad3.cd();
pad3.SetFillColor(10);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
mass_res_cut = new TH1F("mass_res_cut","mass resonant cut",100, 70,90);
jtuple.Draw("m0>>mass_res_cut","abs(m0-m1)<5.0","");
cPar2.Update();
//
//------------------------------------------------------------------------
cPar2.cd();
TPad pad4("pad4","This is pad4", .50,.01, (.50+.48),(.01+.48), 15);
pad4.Draw();
pad4.cd();
pad4.SetFillColor(10);
jtuple.SetLineColor(1);
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
mass_all_cut = new TH1F("mass_all_cut","mass dist all cut", 100,70,90);
//mass_cut     = new TH1F("mass_cut","mass dist ", 100,70,90);
jtuple.Draw( "m0>>mass_all_cut","abs(m0-m1)<5.0","goff");
jtuple.Draw("m2>>+mass_all_cut" ,"abs(m2-m3)<5.0","goff");
jtuple.Draw("m4>>+mass_all_cut" ,"abs(m4-m5)<5.0","goff");
mass_all_cut.Draw(0);
//
mass_combi_cut = new TH1F("mass_combi_cut","mass combinatorial ", 100,70,90);
mass_combi_cut.Add(mass_all_cut,mass_res_cut, 1. , -1.);
mass_combi_cut.Draw("same");
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cPar2.Update();
cPar2.cd();
}
