#ifndef Semaph_H
#define Semaph_H
///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                CLASS Semaph                                               //
//                                                                           //
//    Utility for managing main MC production loop.                          //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////
#include "TROOT.h"


class Semaph : public TNamed {
public:
//
  ifstream   InfileSema;  //! Input semaphore file
  ifstream   InfileSeed;  //! Input seed file
  ofstream   OufileSema;  //! Output semaphore file
  long       ijklin;      // for ranmar
  long       ntotin;      // for ranmar
  long       ntot2n;      // for ranmar
public:
  Semaph();
  ~Semaph() {;}
// dummy copy constructor
private:
  Semaph(const Semaph &org) { }
public:
void Semaph::Initialize(TString &Semaphore);
void Semaph::ReadStatus(TString &Semaphore);
////////////////////////////////////////////////////////////////////////////
  ClassDef(Semaph,1) //Utility for managing main MC production loop
};
////////////////////////////////////////////////////////////////////////////
#endif
