
      SUBROUTINE reader_4v(i_read,ipdg,dbp1,dbp2,dbp3,dbp4,
     @                   sphot,nphot,wtkarl,iend) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION dbp1(4),dbp2(4),dbp3(4),dbp4(4)
      DIMENSION ipdg(4), sphot(100,4), photo(4)

      DIMENSION p1(4),p2(4),p3(4),p4(4)
      DIMENSION ip(4)

      CHARACTER char1

      DATA init /1/
      SAVE 

      IF(i_read.EQ.0) RETURN

      IF(init.EQ.1) THEN
! initialize
         OPEN(22,file='4vect.data.in')
         INIT=0
      ENDIF

! read one point

      iend=0
      wtkarl=1d0
      IF(i_read.EQ.3) THEN
         READ(22,*,end=12) char1
         IF(char1.EQ.'E') THEN
! end of run requested
            GOTO 12
         ENDIF
      ELSEIF(i_read.EQ.4) THEN
         READ(22,*,end=12) char1
         IF(char1.EQ.'E') THEN
! end of run requested
            GOTO 12
         ELSEIF(char1.EQ.'R') THEN
! rejected event
            DO j=1,4
               dbp1(j) =0d0
               dbp2(j) =0d0
               dbp3(j) =0d0
               dbp4(j) =0d0
            ENDDO
            nphot=0
            iend=-1
            wtkarl=0d0
            RETURN
         ENDIF
      ENDIF
      
      READ(22,*,end=12) ip
      
      READ(22,'(4e26.18)') p1 
      READ(22,'(4e26.18)') p2 
      READ(22,'(4e26.18)') p3 
      READ(22,'(4e26.18)') p4 
      
      READ(22,*) nphot
      
      DO i=1,nphot
         READ(22,'(4e26.18)') photo 
         DO j=1,4
            sphot(i,j) =photo(j)
         ENDDO
      ENDDO
      IF(i_read.EQ.4) THEN
         READ(22,'(4e26.18)') wtkarl
      ENDIF

      CALL swapper(ip,p1,p2,p3,p4,
     @                   ipdg,dbp1,dbp2,dbp3,dbp4) 
      
      RETURN
      
! end of file detected
 12   CONTINUE
      iend=1

      END

      SUBROUTINE swapper(ipdg,p1,p2,p3,p4,
     @                   ip,dbp1,dbp2,dbp3,dbp4) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION dbp1(4),dbp2(4),dbp3(4),dbp4(4)
      DIMENSION ip(4)
      DIMENSION p1(4),p2(4),p3(4),p4(4)
      DIMENSION ipdg(4)

      IF(ipdg(1).NE.-ipdg(2) .OR. ipdg(3).NE.-ipdg(4)) THEN
! no swap
c         IF( ipdg(1).EQ.2 .AND. ipdg(3).EQ.3   .OR.
c     @       ipdg(1).EQ.2 .AND. ipdg(3).EQ.5   .OR.
c     @       ipdg(1).EQ.4 .AND. ipdg(3).EQ.5   .OR.
c     @       ipdg(1).EQ.4 .AND. ipdg(3).EQ.1 ) THEN
c! swap W+W- into W-W+
c            ip(1)=ipdg(3)
c            ip(2)=ipdg(4)
c            ip(3)=ipdg(1)
c            ip(4)=ipdg(2)
c            DO i=1,4
c               dbp1(i)=p3(i)
c               dbp2(i)=p4(i)
c               dbp3(i)=p1(i)
c               dbp4(i)=p2(i)
c            ENDDO
c         ELSE
            DO i=1,4
               ip(i)=ipdg(i)
               dbp1(i)=p1(i)
               dbp2(i)=p2(i)
               dbp3(i)=p3(i)
               dbp4(i)=p4(i)
            ENDDO
c         ENDIF
         RETURN
      ENDIF
     
      IF( ipdg(1).EQ.2 .AND. ipdg(3).EQ.3   .OR.
     @    ipdg(1).EQ.2 .AND. ipdg(3).EQ.5   .OR.
     @    ipdg(1).EQ.4 .AND. ipdg(3).EQ.5   .OR.
     @    ipdg(1).EQ.4 .AND. ipdg(3).EQ.1 ) THEN
! swap ZZ to WW
         ip(1)=ipdg(3)
         ip(2)=ipdg(2)
         ip(3)=ipdg(1)
         ip(4)=ipdg(4)
         DO i=1,4
            dbp1(i)=p3(i)
            dbp2(i)=p2(i)
            dbp3(i)=p1(i)
            dbp4(i)=p4(i)
         ENDDO
      ELSEIF( ipdg(1).EQ.1 .AND. ipdg(3).EQ.4   .OR.
     @        ipdg(1).EQ.3 .AND. ipdg(3).EQ.2   .OR.
     @        ipdg(1).EQ.5 .AND. ipdg(3).EQ.2   .OR.
     @        ipdg(1).EQ.5 .AND. ipdg(3).EQ.4 ) THEN
! swap ZZ to WW
         ip(1)=ipdg(1)
         ip(2)=ipdg(4)
         ip(3)=ipdg(3)
         ip(4)=ipdg(2)
         DO i=1,4
            dbp1(i)=p1(i)
            dbp2(i)=p4(i)
            dbp3(i)=p3(i)
            dbp4(i)=p2(i)
         ENDDO
      ELSE
! no swap
         DO i=1,4
            ip(i)=ipdg(i)
            dbp1(i)=p1(i)
            dbp2(i)=p2(i)
            dbp3(i)=p3(i)
            dbp4(i)=p4(i)
         ENDDO
      ENDIF

      END


      SUBROUTINE writer_wt(i_writ,wtset,wtext) 
!     *********************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION wtset(100)

      DATA init /1/
      SAVE 

      IF(i_writ.EQ.0) RETURN

      IF(init.EQ.1) THEN
! initialize
         OPEN(23,file='wtext.data.out')
         INIT=0
      ENDIF

      IF(i_writ.GE.-2 .AND. i_writ.LE.2) THEN
         WRITE(23,'(e26.18)') wtext
      ELSEIF(i_writ.LE.-3 .OR. i_writ.GE.3) THEN
         DO i=1,9
            WRITE(23,'(9e26.18)') wtset(i)
c            WRITE(6,*) 'writer_wt',wtset(i)
         ENDDO
      ENDIF
      call flush(23)
      END


