      SUBROUTINE TOHEP
      DOUBLE PRECISION  QEFF1(4),QEFF2(4),SPHUM(4),SPHOT(100,4)
      DOUBLE PRECISION Q1(4),Q2(4),P1(4),P2(4),P3(4),P4(4)
      DOUBLE PRECISION yyQ1(4),yyQ2(4),yyP1(4),yyP2(4),yyP3(4),yyP4(4)
      INTEGER NPHOT
      COMMON / MOMSET / QEFF1,QEFF2,SPHUM,SPHOT,NPHOT
!      COMMON / MOMDEC / Q1,Q2,P1,P2,P3,P4
      COMMON / MOMDEC / yyQ1,yyQ2,yyP1,yyP2,yyP3,yyP4
      DOUBLE PRECISION ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2
      INTEGER IDE,IDF
      COMMON / WEKING / ENE,AMAZ,GAMMZ,AMEL,AMFIN,XK0,SINW2,IDE,IDF
      COMMON /TAUPOS/ NP1,NP2                
      COMMON /PHOACT/ IFPHOT
      COMMON /TRALID/ idtra
      INTEGER IFLAV(4)
      INTEGER Ipyy(4)
      REAL*4    POL0(4),POL1(4),POL2(4)
      DOUBLE PRECISION  AMDEC(4), amdyy(4)
      COMMON / DECAYS / Ipyy, AMDyy
!      COMMON / DECAYS / IFLAV, AMDEC
C
      REAL*4 APH(4),XPB1(4),XPB2(4),AQF1(4),AQF2(4),XAMD(4),AM
      REAL*4 XP1(4),XP2(4),XP3(4),XP4(4)

      COMMON / KeyKey /  KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp
      INTEGER            KeyRad,KeyPhy,KeyTek,KeyMis,KeyDwm,KeyDwp

! to switch tau polarization OFF in taus from W- (W+) decays set 
!     DATA  POL1 /0.0,0.0,0.0,0.0/
!     DATA  POL2 /0.0,0.0,0.0,0.0/
! note that taus from Z decays are unpolarized, 10/7/98

      DATA  POL0 /0.0,0.0, 0.0,0.0/
      DATA  POL1 /0.0,0.0,-1.0,0.0/
      DATA  POL2 /0.0,0.0,-1.0,0.0/


      SAVE
! first make sure the ZZ-like mix ckm nondiag are convereted into WW
! if in CC03 mode
      Key4f  = MOD(KeyMis,100)/10
      IF(Key4f.EQ.0) THEN
         CALL anti_swapper(ipyy,amdyy,yyp1,yyp2,yyp3,yyp4,
     @                   iflav,amdec,p1,p2,p3,p4) 
      ELSE
! no swap
         DO i=1,4
            amdec(i)=amdyy(i)
            iflav(i)=ipyy(i)
            p1(i)=yyp1(i)
            p2(i)=yyp2(i)
            p3(i)=yyp3(i)
            p4(i)=yyp4(i)
         ENDDO
      ENDIF
! reset WW momenta
      DO i=1,4
         Q1(i)=p1(i)+p2(i)
         Q2(i)=p3(i)+p4(i)
      ENDDO
! end of convertion
C
      DO K=1,4
       AQF1(K)=Q1(K)
       AQF2(K)=Q2(K)
       XP1(K) =P1(K) 
       XP2(K) =P2(K) 
       XP3(K) =P3(K) 
       XP4(K) =P4(K) 
C
       XAMD(K)=AMDEC(K)
      ENDDO

C initial state (1,2)
      AM=AMEL
! e- (0 0 +1 1)
      XPB1(1) = 0d0
      XPB1(2) = 0d0
      XPB1(3) = dsqrt(ene**2 -am**2) !e- (00+11)
      XPB1(4) = ene
! e+ (0 0 -1 1)
      XPB2(1) = 0d0
      XPB2(2) = 0d0
      XPB2(3) =-xpb1(3) !e+ (00-11)
      XPB2(4) = ene

      CALL FILHEP(1,3, 11,0,0,0,0,XPB1,AM,.TRUE.)
      CALL FILHEP(2,3,-11,0,0,0,0,XPB2,AM,.TRUE.)
C primary final state W-W+ (3,4)
      IF (IFLAV(1).eq.-iflav(2)) then
       idwm= 23
       idwp= 23
      else
       idwm=-24
       idwp= 24       
      endif
      AM=sqrt(Q1(4)**2-Q1(3)**2-Q1(2)**2-Q1(1)**2)
      CALL FILHEP(3,2,idwm,1,2,0,0,AQF1,AM,.TRUE.)
      AM=sqrt(Q2(4)**2-Q2(3)**2-Q2(2)**2-Q2(1)**2)
      CALL FILHEP(4,2,idwp,1,2,0,0,AQF2,AM,.TRUE.)
C radiative photons (5 ... 4+NPHOT) (PDG-code for gamma is 22)
      IF(NPHOT.NE.0) THEN
        IP=0
        DO I=1,NPHOT
          DO J=1,4
            APH(J)=SPHOT(I,J)
          END DO
          IF (APH(4).GT.0.0) THEN
            IP=IP+1
            CALL FILHEP(4+IP,1,22,1,2,0,0,APH,0.0,.TRUE.)
          END IF
       END DO
      END IF
C decay products W- (5,6)+NPHOT
      CALL FILHEP(0,1,IFLAV(1),3,3,0,0,XP1,XAMD(1),.TRUE.)
      CALL FILHEP(0,1,IFLAV(2),3,3,0,0,XP2,XAMD(2),.TRUE.)
C decay products W+ (7,8)+NPHOT
      CALL FILHEP(0,1,IFLAV(3),4,4,0,0,XP3,XAMD(3),.TRUE.)
      CALL FILHEP(0,1,IFLAV(4),4,4,0,0,XP4,XAMD(4),.TRUE.)
C

C tau decays:
      if (abs(iflav(1)).eq.15.and.abs(iflav(2)).eq.16) then
          KTO=2
          idtra=1
!          write(*,*) 'id=',idtra
          NP2=5+NPHOT
          CALL DEXAY(KTO,POL2)
 !         write(*,*) '==='
      endif
      if (abs(iflav(4)).eq.15.and.abs(iflav(3)).eq.16) then
          KTO=1
          idtra=4
          NP1=8+NPHOT
          CALL DEXAY(KTO,POL1)
      endif
      if (abs(iflav(1)).eq.15.and.abs(iflav(2)).eq.15) then
          KTO=2
          idtra=1
          NP2=5+NPHOT
          CALL DEXAY(KTO,POL0)
          KTO=1
          idtra=2
          NP1=6+NPHOT
          CALL DEXAY(KTO,POL0)
      endif
      if (abs(iflav(4)).eq.15.and.abs(iflav(3)).eq.15) then
          KTO=2
          idtra=3
          NP2=7+NPHOT
          CALL DEXAY(KTO,POL0)
          KTO=1
          idtra=4
          NP1=8+NPHOT
          CALL DEXAY(KTO,POL0)
      endif
! 7 july 00 WP
C radiate photons for leptonic W decays.
        IF (IFPHOT.GE.1) THEN
!WP          if (abs(iflav(1)).gt.10) CALL PHOTOS(3)
!WP          if (abs(iflav(3)).gt.10) CALL PHOTOS(4)
!WP: Radiate photons also from quarks
           CALL PHOTOS(3)
           CALL PHOTOS(4)
        ENDIF
      END 

      SUBROUTINE anti_swapper(ipdg,amd,p1,p2,p3,p4,
     @                   ip,amdec,dbp1,dbp2,dbp3,dbp4) 
!     *********************************************
! this routine reverses form ZZ convention of mix ckm suppr to WW conv.
! i.e. ssuu -> suus 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)   
      DIMENSION dbp1(4),dbp2(4),dbp3(4),dbp4(4)
      DIMENSION ip(4),amdec(4)
      DIMENSION p1(4),p2(4),p3(4),p4(4)
      DIMENSION ipdg(4),amd(4)

      IF(ipdg(1).NE.-ipdg(2) .OR. ipdg(3).NE.-ipdg(4)) THEN
! no swap
            DO i=1,4
               ip(i)=ipdg(i)
               amdec(i)=amd(i)
               dbp1(i)=p1(i)
               dbp2(i)=p2(i)
               dbp3(i)=p3(i)
               dbp4(i)=p4(i)
            ENDDO
      ELSE
         IF( ipdg(1).EQ.2 .AND. ipdg(3).EQ.3   .OR.
     @        ipdg(1).EQ.2 .AND. ipdg(3).EQ.5   .OR.
     @        ipdg(1).EQ.4 .AND. ipdg(3).EQ.5   .OR.
     @        ipdg(1).EQ.4 .AND. ipdg(3).EQ.1 ) THEN
! swap ZZ to WW
            ip(1)=ipdg(3)
            ip(2)=ipdg(2)
            ip(3)=ipdg(1)
            ip(4)=ipdg(4)
            amdec(1)=amd(3)
            amdec(2)=amd(2)
            amdec(3)=amd(1)
            amdec(4)=amd(4)
            DO i=1,4
               dbp1(i)=p3(i)
               dbp2(i)=p2(i)
               dbp3(i)=p1(i)
               dbp4(i)=p4(i)
            ENDDO
         ELSEIF( ipdg(1).EQ.1 .AND. ipdg(3).EQ.4   .OR.
     @           ipdg(1).EQ.3 .AND. ipdg(3).EQ.2   .OR.
     @           ipdg(1).EQ.5 .AND. ipdg(3).EQ.2   .OR.
     @           ipdg(1).EQ.5 .AND. ipdg(3).EQ.4 ) THEN
! swap ZZ to WW
            ip(1)=ipdg(1)
            ip(2)=ipdg(4)
            ip(3)=ipdg(3)
            ip(4)=ipdg(2)
            amdec(1)=amd(1)
            amdec(2)=amd(4)
            amdec(3)=amd(3)
            amdec(4)=amd(2)
            DO i=1,4
               dbp1(i)=p1(i)
               dbp2(i)=p4(i)
               dbp3(i)=p3(i)
               dbp4(i)=p2(i)
            ENDDO
         ELSE
! no swap
            DO i=1,4
               amdec(i)=amd(i)
               ip(i)=ipdg(i)
               dbp1(i)=p1(i)
               dbp2(i)=p2(i)
               dbp3(i)=p3(i)
               dbp4(i)=p4(i)
            ENDDO
         ENDIF
      ENDIF

      END


