*////////////////////////////////////////////////////////////////////////////////
*//     !!!!!!      This file is OBSOLETE           !!!!!!                     //
*//               Replacement is KW.f + KW.h                                   //
*////////////////////////////////////////////////////////////////////////////////

      SUBROUTINE koralw_obsolete(mode,xpar_input)
*////////////////////////////////////////////////////////////////////////////////
*//   ======================================================================   //
*//   ======================================================================   //
*//   ===========================KORALW=====================================   //
*//   ======================WW pair production==============================   //
*//   =================initial state exponentiation=========================   //
*//   ======================================================================   //
*//   ======================================================================   //
*//   ======================== version 1.42 ================================   //
*//   ======================================================================   //
*//   ========================= August 1998 ================================   //
*//   ======================================================================   //
*////////////////////////////////////////////////////////////////////////////////
*     This program is written by:
*          S. Jadach      (Stanislaw.Jadach@cern.ch)
*          W. Placzek     (Wieslaw.Placzek@cern.ch)
*          M. Skrzypek    (Maciej.Skrzypek@cern.ch)
*          B.F.L. Ward    (bflw@slac.stanford.edu)
*          Z. Was         (Zbigniew.Was@cern.ch)
*////////////////////////////////////////////////////////////////////////////////
* INPUT:
* mode =-1/0/1/2 defines
*       initialization/generation/give-xsection/final-report
* All other in put is in data_DEAFAULT file which has to be read
* separately with KoralW_ReaDataX, see demo demostration program
*////////////////////////////////////////////////////////////////////////////////
* OUTPUT momenta:
* Four-momenta and photon multiplicity in standard COMMON hepevt:
*      COMMON/hepevt/nevhep,nhep,isthep(nmxhep),idhep(nmxhep),
*     &jmohep(2,nmxhep),jdahep(2,nmxhep),phep(5,nmxhep),vhep(4,nmxhep)
* Also in the KORALW internal COMMON's /momset/ and /momdec/:
*     COMMON / momset / qeff1(4),qeff2(4),sphum(4),sphot(100,4),nphot
*         effective PARAMETERs for matr.el. only (e-,e+); ... ;photons ;phot. multip
*     COMMON / momdec / q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
*        w- ;w+ ;f (w-);\bar f (w-);f (w+);\bar f (w+);
*////////////////////////////////////////////////////////////////////////////////
* OUTPUT normalization:
* xpar(20)  =XsecMC = Mote Carlo total cross section in picobarns
* xpar(21)  =XErrMC = Mote Carlo error in picobarns
* xpar(30)  =XnorMC = Normalization  cross section in picobarns,  
*                   = XsecMC for WtMod=1 events, and 
*                   = Crude xsection for variable weight events
* xpar(31)  =wtmax  = maximum wt used for rejection (obsolete)
* xpar(1010)=nevtru = number of accepted unweighted events or
*                   number of generated weighted events
* xpar(1011)=nevtot = number of generated events (before rejection)
*                   (for weighted events nevtru=nevtot)
*////////////////////////////////////////////////////////////////////////////////
* OUTPUT weights:
* Normaly the user may request with KeyWgt=1 weighted events and then
* should use  PRINCIPAL model weight WtMod from the COMMON block /wgtall/.
*
* For advanced users only: for KeyWgt=1 instead of WtMod user
* may use WtAux = wtcrud*wtset(i), where  wtcrud and wtset(i) are from
* in COMMON block /wgtall/.
* The meaning of auxiliary WtAux is the following:
*     wtset( 1) =   born
*     wtset( 2) =   first order
*     wtset( 3) =   second order
*     wtset( 4) =   third order
* and the corresponding components
*     wtset(11-12) =   first order, betas
*     wtset(13-15) =   second order, betas
*     wtset(16-19) =   third order, betas
* N.B. wtmod=wtcrud*wtset(4) in standard case with ISR
*      wtmod=wtcrud*wtset(1) in case of no ISR bremsstrahlung
* in the case of the external four-fermion matrix el. the corresponding 
* Matrix element is provided in
*     wtset(40)=wtbo4f 
*     wtset(40+i4f)=wt4f(i4f) provide place for additional information
* from external matrix el. if set by the user. These slots are not used.
*////////////////////////////////////////////////////////////////////////////////
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      SAVE
      REAL*8  xpar_input( 10000) ! in main program
      REAL*8  xpar( 10000)       ! local
      INTEGER npar( 1000)        ! local
* Work-area for internal histogramming package Glibk
      COMMON / cglib / blibk(50000)
      SAVE   / cglib /
*
      COMMON / matpar / pi,ceuler
      COMMON / phypar / alfinv,gpicob
      COMMON / momset / qeff1(4),qeff2(4),sphum(4),sphot(100,4),nphot
      COMMON / momdec / q1(4),q2(4),p1(4),p2(4),p3(4),p4(4)
      COMMON / cms_eff_momdec /
     $      effbeam1(4),effbeam2(4),effp1(4),effp2(4),effp3(4),effp4(4)
      COMMON / weking / ene,amaz,gammz,amel,amfin,xk0,sinw2,ide,idf
      COMMON / wekin2 / amaw,gammw,gmu,alphaw
      COMMON / wt_max / wtmax,wtmax_cc03     
*
* this COMMON can be everywhere, contains various switches
      COMMON / keykey/  keyrad,keyphy,keytek,keymis,keydwm,keydwp
* tauola, photos and jetset overall switches
      COMMON / libra  / jak1,jak2,itdkrc,ifphot,ifhadm,ifhadp
*
* wtborn is added in koralw
      COMMON / wgtgen / wtves,wtyfs,wtborn
      COMMON / wgtall / wtcrud,wtmod,wtset(100)
      COMMON / inout  / ninp,nout
      COMMON / bxfmts / bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g
      CHARACTER*80      bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g
      COMMON / decays / IFlav(4), amdec(4) 
      COMMON / DECDAT / AMAFIN(20), BR(20)

*-- 4fermion weights
      DIMENSION wt4f(9)
*-- vector of random numbers
      DIMENSION drvec(100)
*-- single precision parameter for tauola
      REAL pol(4)

      DIMENSION bsp(4)
*-- dipswitch kardmp:  printout on wt over wtmax: 1-on, 0-off
      DATA kardmp /1/
* ==================================================================
* =====================initialization===============================
* ==================================================================
*     *******************
      IF(mode .EQ. -1) THEN
*     *******************
*///////////////////////////////////////////////////////////////
*//        Compulsory Initialization of GLIBK                 //
*///////////////////////////////////////////////////////////////
      CALL glimit(50000)
      CALL goutpu(nout)
*////////////////////////////////////////////////////////////////////////////
*// Xpar should be  essentialy an image of the input in the main program   //
*// In the present version it also plays role of additional "common block" //
*// communicating between subprograms, vide filexp.f and setmas_koralw.f   //
*// In order to split this double role I introduce xpar_input which is not //
*// modified (see exception below)  and local xpar which acts as additional//
*// address area residing in THIS program and sent as a pointer downwards. //
*// Now the main program (including Korwan) knows nothing about changes    //
*// in local the xpar done in filexp.                                      //
*// Exception is that xpar_input sends information outside for mode=1,2.   //
*// This role should disappear, and final XsecMC should have its "getter"  //
*// Of course, xpar_input is copied into xpar, see below:                  //
*////////////////////////////////////////////////////////////////////////////
      DO i = 1, 10000
         xpar(i) = xpar_input(i)
      ENDDO
* initialization of COMMON blocks
* translation xpar-->npar
      CALL FILExp_Obsolete(xpar,npar)
*= = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
* identificator for this generator
      idgen = 7
* important histo which remembers total x-section
      CALL gmonit(-1, idgen,1d0,1d0,1d0) ! idgen=7
*= = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
* this is "pointer" for internal monitoring histograms/averages
      idyfs = 0
      svar=4*ene**2
      keywgt = MOD(keytek,10)
      keysmp = MOD(keytek,1000)/100
      keyisr = MOD(keyrad,10)
      key4f  = MOD(keymis,100)/10
      KeyAcc = MOD(KeyMis,1000)/100
! Soft photon cut-off
      vvmin  = xpar(8)
! Strong coupling constant
      alpha_s = xpar(13)
! Colour Re-Connection probability
      PReco = xpar(19)
      DO i=1,100
        wtset(i)=0
      ENDDO
*!!!!!!!!!! this should go out to tests [[[[[[[[[[[[[[[
* ============================================================
* let us keep for KORALW the glibk id-ent range from 2 to 1000
* ============================================================
* Principal weight 
      CALL gmonit(-1,idyfs+80,0d0,1d0,1d0)  ! total xs
      CALL gmonit(-1,idyfs+81,0d0,1d0,1d0)  ! xs for wt<0
      CALL gmonit(-1,idyfs+82,0d0,1d0,1d0)  ! xs for wt>wtmax
*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!]]]]]]]]]]]]]]]
      WRITE(6,*) 'KORALW  <-3>'
*-- initialization of qed part
      CALL karlud(-1,xcrude,dum2,dum3)
      ievacc=0
      nevtot=0
      nevtru=0
cccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccc
* initialization tauola photos etc.
*!      IF( keywgt  .EQ.  0) THEN
         WRITE(6,*) '>>>>>>>> initialization tauola photos etc.'
         CALL  inietc(npar(21),npar(22),npar(23),npar(24))
         CALL  inimas
         CALL  iniphx(0.01d0)
         CALL  initdk
         CALL  phoini
*!      ENDIF
cccccccccccccccccccccccccccccccccc
* initialization of 4fermion matrix el. libraries
      IF( key4f .NE. 0 ) THEN
        CALL ampinw(xpar,npar)
      ENDIF
cccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccc
      wtu=0d0
!-- activates 4fermion tests
      i_4f=1
!-- beta functions tests, activated with i_beta=1
      i_beta=1
      IF( keyisr .NE. 0 ) THEN
*-- initialize tests of beta functions
         IF(i_beta. EQ. 1) CALL beta_tests(-1,idyfs,xcrude,wtkarl,wtset)
      ENDIF
!-- 4fermion monitoring
      IF(i_4f .EQ. 1) 
     $  CALL f4_tests(-1,idyfs,xcrude,wttot,wtboww,wtbo4f,wt4f) 
! monitoring xsections in different decay channels
      CALL decay_monit(-1,wtmod,xcrude,svar,label_dumm,nout)
! counter for z_ libraries reset
      CALL z_counter(-1,idum)
!======== weights monitoring beg ===========
      DO i=58,60
        CALL gmonit(-1,idyfs+i,0d0,1d0,1d0)
      ENDDO
!======== weights monitoring end ===========
* ==================================================================
* ========================generation================================
* ==================================================================
*     ***********************
      ELSEIF(mode .EQ. 0) THEN
*     ***********************
      nevtru=nevtru+1
! fill the counter (it counts nevtru)
      CALL z_counter(0,idum)
 200  CONTINUE
      nevtot=nevtot+1
      CALL karlud( 0,xcborn,wtkarl,wtdumm)
! find out the label
      CALL store_label(1,label)
! check if requested final state is a CC03 + MIX + doubly CKM suppresses 
! if so it is 'NC03'  and we suppress it
! equivalently it is ZZ with CC03
      CALL linear_to_WZ_label(1,label,icwm,icwp,if_z,if_w)
      IF(key4f.EQ.0 .AND. if_z.EQ.1) THEN
        wtkarl=0d0
        wtborn=0d0
      ENDIF
      wtcrud = wtkarl
*     ============================
      IF( KeyWgt .EQ. 2 ) THEN
*     ============================
*********************************************************
*   Constant weight (wt=1) events for internal CC03     *
*********************************************************
         IF (wtcrud .NE. 0d0) THEN
           wtcc03 = wwborn(effp1,effp2,effp3,effp4,keyacc)
           DO i=1,4
             bsp(i) = effp1(i)+effp2(i)+effp3(i)+effp4(i)
           ENDDO
           sp = dmas2(bsp)
*-- Born level flux factor 1/2s'
           fluxf = 1d0/(2d0*sp)
           wtcc03 = wtcc03*fluxf*gpicob
           wtbww = wtcrud*wtcc03
!---------------------------
!-- pseudo-rejection loop for internal CC03
           CALL varran(drvec,1)
           rn = drvec(1)
           IF (wtbww .LT. rn*wtmax_cc03) THEN
             wtcrud = 0d0
           ELSE
             wtcrud = wtmax_cc03/wtcc03
           ENDIF
!---------------------------
         ENDIF
       ENDIF
********************************************************
*-- (CC03,4-fermions) + Coulomb + ACC + nQCD weights --*
********************************************************
      CALL model_4f(wtcrud,wtboww,wtbo4f,wt4f,br,alpha_s,
     $              effp1,effp2,effp3,effp4,label,key4f,keyacc)
*---
!-- CC03 Born weight
      wtwwpb = wtboww*gpicob
!-- Total Born weight (4f) 
      wtborn = wtbo4f*gpicob
*---------------------------------------------------------
!======== weights monitoring begin ===========
!-- phase space volume (crude weight, no Born) 
      CALL gmonit(0,idyfs+59,wtcrud, 0d0,0d0)
!-- CC03 Born, no betas
      wtbww = wtcrud*wtwwpb
      CALL gmonit(0,idyfs+58,wtbww, wtmax_cc03,0d0)
!-- cc03 born OVER wtmax, no betas
      wtovr = MAX(0d0,wtbww - wtmax_cc03)
      CALL gmonit(0,idyfs+60,wtovr, 0d0,0d0)
* Correcting "bad" QED t-channel weights for eexx final states 
      CALL eexx_wt_cor(wtcrud,svar,amel,iflav,vvmin,wtcort)
      wtborc = wtborn *wtcort
*  QED  ISR model weight
      IF( keyisr .NE. 0 ) THEN
         CALL betar(alfinv,wtborc,svar,amel,nphot,sphot,wtset)
*-- tests of beta functions
         IF(i_beta. EQ. 1) 
     $       CALL beta_tests(0,idyfs,xcrude,wtcrud,wtset) 
      ENDIF
*---------------------------------------------------------
* **********************************
*       Total (principal) weight
* **********************************
      IF( keyisr  .EQ.  0 ) THEN
        wttot    =wtcrud*wtborn
        wtset(1) =wtborn
      ELSE
        wttot    =wtcrud*wtset(4)
      ENDIF
!==================================================
! total weight monitoring
      CALL gmonit(0,idyfs+80,wttot,  wtmax,0d0)
! events with wt<0
      wtneg = MIN(wttot,0d0)
      CALL gmonit(0,idyfs+81,wtneg,  0d0,0d0)
! events with wt>wtmax
      wtovr = MAX(0d0,wttot-wtmax)
      CALL gmonit(0,idyfs+82,wtovr,  0d0,0d0)

! monitoring xsections in different decay channels
      CALL decay_monit(0,wttot,xcrude,svar,label,nout)

!-- 4fermion monitoring
      IF(i_4f .EQ. 1) 
     $       CALL f4_tests(mode,idyfs,xcrude,wttot,wtboww,wtbo4f,wt4f)
!==================================================
!======== weights monitoring end ===========
*     ============================
      IF( KeyWgt .EQ. 0 ) THEN
*     ============================
********************************************
*       Constant weight (wt=1) events      *
********************************************
!---------------------------
!-- principal rejection loop
         CALL varran(drvec,1)
         rn = drvec(1)
         IF (wttot .LT. rn*wtmax ) GOTO 200
!---------------------------
         DO i=1,100
            wtset(i)=0
         ENDDO
         wtcrud = 1d0
! Principal event weight =1 now!
         wtmod  = 1d0
*     ============================
      ELSEIF( KeyWgt .EQ. 1 ) THEN
*     ============================
*****************************************
*        Variable weight events         *
*****************************************
! Principal event weight
         wtmod = wttot
! Remembers crude x-section and total number of events 
         CALL gmonit(  0, idgen,      xcrude, wtmax,0d0)
*     =====
      ELSEIF( KeyWgt .NE. 2) THEN
*     =====
         WRITE(6,*)'KORALW==>wrong keywgt=',keywgt
         STOP
*     =====
      ENDIF
*     =====
*-------------------
* dump for debugging
*-------------------
      IF(keysmp .EQ. 2  .AND.  kardmp .EQ. 1
     @    .AND.  wttot/wtmax .GE. 1d0) THEN
        wtu=max(wttot/wtmax,wtu)
        CALL mm_dumper(12,6,nevtru,wttot,wtu,wtmax,wtmod,wtbo4f,iflav)
        CALL ww_dumper(6,svar,amel,wtcort) 
      ELSEIF( keysmp .EQ. 1  .AND.  kardmp .EQ. 1
     @    .AND.  (wttot/wtmax .GT. 1d0  .OR.  nevtru .EQ. -3320) ) THEN
        wtu=max(wttot/wtmax,wtu)
        CALL zz_dumper(6,nevtru,wttot,wtu,wtmax,wtmod,wtbo4f,iflav)
        CALL ww_dumper(6,svar,amel,wtcort) 
      ELSEIF( keysmp .EQ. 3  .AND.  kardmp .EQ. 1
     @    .AND.  wttot/wtmax .GT. 1d0 ) THEN
        wtu=max(wttot/wtmax,wtu)
        CALL mm_dumper(12,6,nevtru,wttot,wtu,wtmax,wtmod,wtbo4f,iflav)
        CALL ww_dumper(6,svar,amel,wtcort) 
        CALL zz_dumper_short(6)
      ENDIF
*-------------------
* END dump for debugging
*-------------------
      wtset(40)=wtbo4f
      DO i4f=1,9
        wtset(40+i4f)=wt4f(i4f)
      ENDDO
*--------------------------------------------------------------------
* ccccccccccccccccccccccccccccccccc
      IF( wtcrud  .NE.  0d0) THEN
* ccccccccccccccccccccccccccccccccc
* tohep sets into hepevt all generated particles.
*       it decays taus and generates bremsstrahlung
*       in tau and w decays.
         CALL tohep
* and tohad moves to lund FORMAT.
* it hadronizes whatever requires.
         CALL tohad(ifhadm,ifhadp,PReco)
      ELSE
* some routine to set hepevt to 0 should be here <<<<<============
        CONTINUE
* ccccccccccccccccccccccccccccccccc
      ENDIF
* ccccccccccccccccccccccccccccccccc
      IF(  (nevtru .LE. 1 .OR. nevtru .EQ. 2000000) 
     $     .AND. wtkarl .GT. 0d0       ) THEN
         CALL dumpl(6,p1,p2,p3,p4,qeff1,qeff2,sphot,nphot)
         CALL dumpw(nout)
      ENDIF
*-- presampler channels monitoring
      IF( keysmp  .EQ.  2 ) CALL pres_monit(0,wtcrud,wtmod,wtset)
!!! temporary, to monitor progress of the accuracy with statistics
      IF(mod(nevtot,200000).EQ.0) THEN
        CALL decay_monit(1,wtmod,xcrude,svar,label_dumm,6)
      ENDIF
* ==================================================================
* ====================postgeneration================================
* ==================================================================
*     *************************
      ELSEIF( mode .EQ. 1) THEN
*     *************************
      CALL karlud(1,xcrude,xcvesk,dumm1)
*-- presampler channels monitoring
      IF( keysmp  .EQ.  2 ) CALL pres_monit(1,wtcrud,wtmod,wtset)
* ccccccccccccccccccccccccccccccccc
* final printouts of tauola
      keywgt = MOD(keytek,10)
      IF( keywgt  .EQ.  0) THEN
         CALL dexay(100,pol)
      ENDIF
* ccccccccccccccccccccccccccccccccc
!---- stuff moved from karlud beg ----
*-- crude xs. no born
      CALL gmonit(1,idyfs+59,wtkacr,erkacr,parm3)
      CALL gmonit(2,idyfs+59,evacc,evneg,evove)
      nevneg = evneg
      nevtot = parm3
      WRITE(nout,bxope)
      WRITE(nout,bxtxt) '         KORALW  final  report '
      WRITE(nout,bxtxt) '               Window A        '
      WRITE(nout,bxtxt) '            WEIGHTED evts.     '
      WRITE(nout,bxtxt) '                               '
      WRITE(nout,bxtxt) ' ccru matrix element means:    '
      WRITE(nout,bxtxt) ' a) Born matrix element for CC03 processes  '
      WRITE(nout,bxtxt) ' b) technical crude m.e. for nc processes or'
      WRITE(nout,bxtxt) '    for keysmp .NE. 0                       '
      WRITE(nout,bxtxt) '                               '
      WRITE(nout,bxtxt) '     xsect with no matrix element   '
      WRITE(nout,bxl1i) nevtot,'total no of events      ','nevtot','a0'
      WRITE(nout,bxl1i) nevneg,'wtcrud < 0 evts         ','nevneg','a1'
      xskr   = xcrude*wtkacr
      erkr   = xskr*erkacr
      WRITE(nout,bxl1g) xcrude,'sigma_crude             ','xcrude','a2'
      WRITE(nout,bxl2g) 
     $           wtkacr,erkacr,'<wtcrud>, rel err       ','wtkacr','a3'
      WRITE(nout,bxl2g)
     $              xskr,erkr,'phsp. vol, no beta-0     ','xskr  ','a4'
      WRITE(nout,bxtxt) ' '

*-- born xsection, total
      CALL gmonit(1,idyfs+58,wtkabo,erkabo,parm3)
      CALL gmonit(2,idyfs+58,evacc,evneg,evove)
      nevneg = evneg
      nevove = evove
      nevtot = parm3
      xskb0  = xcrude*wtkabo
      erkb0  = xskb0*erkabo
      WRITE(nout,bxtxt) '                               '
      WRITE(nout,bxtxt) ' xsect with ccru matrix el. only, no betas'
      WRITE(nout,bxl1i) nevtot,'total no of events      ','nevtot','a5'
      WRITE(nout,bxl1i) nevneg,'wtcrud*wtborn <0 evts   ','nevneg','a6'
      WRITE(nout,bxl2g)
     $           wtkabo,erkabo,'<wtcrud*wtborn>, rel err','wtkabo','a7'
      WRITE(nout,bxl2g)
     $           xskb0,erkb0,  'sigma (born m.el.)      ','xska0','a8'

*-- born xsection from above wtmax
      CALL gmonit(1,idyfs+60,wtkabo,erkabo,parm3)
      xskb   = xcrude*wtkabo
      erkb   = xskb*erkabo
      IF (xskb.NE.0d0) THEN
        xx=xskb/xskb0
        ee=erkb/xskb0
      ELSE
         xx=0d0
         ee=0d0
      ENDIF
      WRITE(nout,bxtxt) '                               '
      WRITE(nout,bxtxt) '     xsect over wtmax_cc03     '
      WRITE(nout,bxtxt) ' ccru matrix el. only, no betas'
      WRITE(nout,bxl1i) nevove,   'evts: wt>wtmax_cc03  ','nevove','a9'
      WRITE(nout,bxl2g) xskb,erkb,'sigma: wt>wtmax_cc03 ','xskabo','a10'
      WRITE(nout,bxl2g) xx,ee,    'relat sigma: wt>wtmax','xskabo','a11'
      WRITE(nout,bxclo)
!---- stuff moved from karludw end ----
      IF( keyisr  .NE.  0 ) THEN
*-- tests of beta functions
        IF(i_beta. EQ. 1) CALL beta_tests(1,idyfs,xcrude,wtkarl,wtset)
      ENDIF
*-- best xsection printout, total and over
      CALL gmonit(1,idyfs+80,averwt,errela,evtot)
      xsbest  = xcrude*averwt
      erbest  = xsbest*errela
      CALL gmonit(2,idyfs+80,evacc,evneg,evove)
      nevacc = evacc
      nevneg = evneg
      nevove = evove
      CALL gmonit(1,idyfs+81,averwn,erreln,evtot)
      xsneg   = averwn/averwt
      erneg   = xsneg*erreln
      CALL gmonit(1,idyfs+82,averwo,errelo,evtot)
      xsove   = averwo/averwt
      erove   = xsove*errelo
      WRITE(nout,bxope)
      WRITE(nout,bxtxt) '         KORALW  final  report '
      WRITE(nout,bxtxt) '               Window C        '
      WRITE(nout,bxtxt) '                               '
      WRITE(nout,bxtxt) '     BEST order total xsect.   '
      WRITE(nout,bxl1i)nevtot,       'total no of events ','nevtot','c1'
      WRITE(nout,bxl1i)nevtru,       'accepted events    ','nevtru','c2'
      WRITE(nout,bxl2g)xsbest,erbest,'sigma_tot [pb]     ','xskabo','c3'
      WRITE(nout,bxl1f)errela,       'relative error     ','errela','c4'
      WRITE(nout,bxl1i)nevneg,       'events: wt<0       ','nevneg','c5'
      WRITE(nout,bxl2g)xsneg,erneg,  'xsec/xtot: wt<0    ','xsneg ','c6'
      WRITE(nout,bxl1i)nevove,       'events: wt>wtmax   ','nevove','c7'
      WRITE(nout,bxl2g)xsove,erove,  'xsec/xtot: wt>wtmax','xsove ','c8'
      WRITE(nout,bxclo)
      IF( key4f  .NE.  0 ) THEN
!-- 4fermion monitoring
         IF(i_4f .EQ. 1) 
     $     CALL f4_tests(mode,idyfs,xcrude,wttot,wtboww,wtbo4f,wt4f)
      ENDIF
! monitoring xsections in different decay channels
      CALL decay_monit(1,wtmod,xcrude,svar,label_dumm,nout)
**********
* on request also the printout for the photonic pre-tabulation
*********      CALL decay_monit(2,wtmod,xcrude,svar,label_dumm,nout)
*-- output parameters
      IF( KeyWgt .EQ. 0 ) xcrude = xsbest
c[[[[[[[[[[ OBSOLETE [[[[[[[[[[[[[[[[[[[[
      xpar_input(20)=xsbest
      xpar_input(21)=erbest
***   npar(10)=nevtru           !!! <--not accsessible outside koralw
***   npar(11)=nevtot           !!! <--not accsessible outside koralw
      xpar_input(1010)=nevtru
      xpar_input(1011)=nevtot
*-- normalization factor for histogramming
      IF( KeyWgt .EQ. 0 ) THEN
        xpar_input(30)=xsbest
      ELSE
        xpar_input(30)=xcrude
      ENDIF
      xpar_input(31)=wtmax
      xpar_input(32)=wtmax_cc03
c]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]
*****************************************************************
*****************************************************************
*     **********************
      ELSEIF(mode .EQ. 2) THEN
*     **********************
      CALL karlud(mode,dum1,xsborn,erborn)
*     ****
      ELSE
*     ****
      WRITE(nout,*) '===>KORALW: wrong mode'
      STOP
*     *****
      ENDIF
*     *****
      END

      SUBROUTINE model_4f(wtcrud,wtboww,wtbo4f,wt4f,br,alpha_s,
     $                    effp1,effp2,effp3,effp4,label,key4f,keyacc)
!     ****************************************************************
! external weight connected with 4fermions
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON / MATPAR / PI,CEULER    
      SAVE / MATPAR /

      DIMENSION wt4f(9),br(20)
      DIMENSION effp1(4),effp2(4),effp3(4),effp4(4)
      DIMENSION bq1(4),bq2(4),bsp(4)

      DIMENSION ipdg(4)
      CHARACTER*3 chuman(4)

      IF (wtcrud .NE. 0d0) THEN
         DO i=1,4
            bq1(i) = effp1(i)+effp2(i)
            bq2(i) = effp3(i)+effp4(i)
            bsp(i) = bq1(i)+bq2(i)
         ENDDO
         s1 = dmas2(bq1)
         s2 = dmas2(bq2)
         sp = dmas2(bsp)
*-- Born level flux factor 1/2s'
         fluxf = 1d0/(2d0*sp)
*-- WW type final states
        CALL linear_to_WZ_label(1,label,iwm,iwp,if_z,if_w)
        IF( if_w .NE. 0 ) THEN
*--- Internal WW Born matrix element
           wtborn = wwborn(effp1,effp2,effp3,effp4,keyacc)
*-- Coulomb corr.
           cc = CulMC(sp,s1,s2)
           wtborc = wtborn*cc
           wtboww = fluxf*wtborc

           IF (key4f.GT.0) THEN
*---  External 4fermion matrix el.
              CALL ampext(wtmod4f,wt4f )
*---  SM CC03 Born
              IF (keyacc .EQ. 0) THEN
                wtborn_sm = wtborn
              ELSE
                wtborn_sm = wwborn(effp1,effp2,effp3,effp4,0)
              ENDIF
*--- Divide off naive QCD correction from wtborn_sm if included
              CALL NAIVE_QCD(label,br,wt_qcd)
*--- ACC & Coulomb corrections to CC03 Born (divide off naive QCD)
              dif_bc = (wtborc - wtborn_sm)/wt_qcd
!ms tests beg
!              rat_bc = wtborc / wtborn_sm
!ms tests end
*--- 4fermion "improved" Born (naive QCD correction - multiplicative) 
              wtbo4f = (wtmod4f + dif_bc)*wt_qcd*fluxf
!ms tests beg
!              wtbo4f = (wtmod4f*rat_bc)*fluxf
!ms tests end
              DO i4f=1,9
                 wt4f(i4f) = (wt4f(i4f) + dif_bc)*wt_qcd*fluxf
              ENDDO
           ELSE
              wtbo4f = wtboww
              DO i4f=1,9
                 wt4f(i4f)=0d0
              ENDDO
           ENDIF
*-- ZZ type final states (pure 4fermion Born)
         ELSE
           CALL ampext(wtmod4f,wt4f ) 
* alpha_s/pi for naive QCD corrections
           aspi = alpha_s/pi
* Naive QCD correction - multiplicative
           wt_qcd = 1d0
           CALL linear_to_pdg_label(1,label,ipdg,chuman)
           IF (abs(ipdg(1)) .LT. 10) wt_qcd = wt_qcd*(1 + aspi)
           IF (abs(ipdg(3)) .LT. 10) wt_qcd = wt_qcd*(1 + aspi)
* 4fermion "improved" Born 
           wtbo4f = wtmod4f*wt_qcd*fluxf
           wtboww = 0d0
         ENDIF
      ELSE
         wtboww = 0d0
         wtbo4f = 0d0
         DO i4f=1,9
            wt4f(i4f)=0d0
         ENDDO
      ENDIF

      END

      SUBROUTINE beta_tests(mode,idyfs,xcrude,wtkarl,wtset)
!     ***********************************************
! beta functions related tests
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / matpar / pi,ceuler
      COMMON / phypar / alfinv,gpicob
 
      COMMON / bxfmts / bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g
      CHARACTER*80      bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g

      COMMON / inout  / ninp,nout

      DIMENSION wtset(*)

      IF(mode .EQ. -1) THEN
* Totals O(alf0-alf3)
         DO k=10,14
            CALL gmonit(-1,idyfs+k,0d0,1d0,1d0) ! 10-14
         ENDDO
* Betas O(alf0-alf3) and differences
         DO k=20,38
            CALL gmonit(-1,idyfs+k,0d0,1d0,1d0) ! 20-38
         ENDDO
      ELSEIF(mode .EQ. 0) THEN
*     Totals O(alf0-alf3)
         DO k=1,4
            CALL gmonit(0,idyfs+10+k,wtkarl*wtset(k),1d0,1d0)
         ENDDO
* Betas O(alf0-alf3)
         DO k=10,19
            CALL gmonit(0,idyfs+10+k,wtkarl*wtset(k),1d0,1d0)
         ENDDO
* Differences total O(alf0-alf3)
         CALL gmonit(0,idyfs+30,wtkarl*(wtset(2)-wtset(1)),1d0,1d0)
         CALL gmonit(0,idyfs+31,wtkarl*(wtset(3)-wtset(2)),1d0,1d0)
         CALL gmonit(0,idyfs+32,wtkarl*(wtset(4)-wtset(3)),1d0,1d0)
* bt01-bt00, bt10
         CALL gmonit(0,idyfs+33,wtkarl*(wtset(11)-wtset(10)),1d0,1d0)
* bt02-bt01, bt11-bt10, bt20
         CALL gmonit(0,idyfs+34,wtkarl*(wtset(13)-wtset(11)),1d0,1d0)
         CALL gmonit(0,idyfs+35,wtkarl*(wtset(14)-wtset(12)),1d0,1d0)
* bt03-bt02, bt12-bt11, bt21-bt20,bt30
         CALL gmonit(0,idyfs+36,wtkarl*(wtset(16)-wtset(13)),1d0,1d0)
         CALL gmonit(0,idyfs+37,wtkarl*(wtset(17)-wtset(14)),1d0,1d0)
         CALL gmonit(0,idyfs+38,wtkarl*(wtset(18)-wtset(15)),1d0,1d0)
      ELSEIF(mode .EQ. 1) THEN
        WRITE(nout,bxope)
        WRITE(nout,bxtxt) '         KORALW  final  report '
        WRITE(nout,bxtxt) '               Window B        '
        WRITE(nout,bxtxt) '                               '
*****************************************************************
*****************************************************************
        CALL gmonit(1,idyfs+11,averwt,errela,evtot)
        xstot0   = xcrude*averwt
        ertot0   = xstot0*errela
        WRITE(nout,bxl2f) xstot0,ertot0,'xsec total    ','O(alf0)','b3'
*****************************************************************
        CALL gmonit(1,idyfs+12,averwt,errela,evtot)
        xstot1   = xcrude*averwt
        ertot1   = xstot1*errela
        WRITE(nout,bxl2f) xstot1,ertot1,'xsec total    ','O(alf1)','b4'
*****************************************************************
        CALL gmonit(1,idyfs+13,averwt,errela,evtot)
        xstot2   = xcrude*averwt
        ertot2   = xstot2*errela
        WRITE(nout,bxl2f) xstot2,ertot2,'xsec total    ','O(alf2)','b5'
*****************************************************************
        CALL gmonit(1,idyfs+14,averwt,errela,evtot)
        xstot3   = xcrude*averwt
        ertot3   = xstot3*errela
        WRITE(nout,bxl2f) xstot3,ertot3,'xsec total    ','O(alf3)','b6'
*****************************************************************
        CALL gmonit(2,idyfs+11,evacc1,evneg1,evove1)
        CALL gmonit(2,idyfs+12,evacc2,evneg2,evove2)
        CALL gmonit(2,idyfs+13,evacc3,evneg3,evove3)
        CALL gmonit(2,idyfs+14,evacc4,evneg4,evove4)
        neg0=evneg1
        neg1=evneg2
        neg2=evneg3
        neg3=evneg4
        WRITE(nout,bxl1i) neg0,         'wt<0  events  ','O(alf0)',' '
        WRITE(nout,bxl1i) neg1,         'wt<0  events  ','O(alf1)',' '
        WRITE(nout,bxl1i) neg2,         'wt<0  events  ','O(alf2)',' '
        WRITE(nout,bxl1i) neg2,         'wt<0  events  ','O(alf3)',' '
*****************************************************************
        CALL gmonit(1,idyfs+20,averwt,errela,evtot)
        xsbt00   = xcrude*averwt
        erbt00   = xsbt00*errela
        WRITE(nout,bxl2f) xsbt00,erbt00,'xsec(beta00)  ','O(alf0)','b7'
*****************************************************************
        CALL gmonit(1,idyfs+21,averwt,errela,evtot)
        xsbt01   = xcrude*averwt
        erbt01   = xsbt01*errela
        WRITE(nout,bxl2f) xsbt01,erbt01,'xsec(beta01)  ','O(alf1)','b8'
*****************************************************************
        CALL gmonit(1,idyfs+22,averwt,errela,evtot)
        xsbt10   = xcrude*averwt
        erbt10   = xsbt10*errela
        WRITE(nout,bxl2f) xsbt10,erbt10,'xsec(beta10)  ','O(alf1)','b9'
*****************************************************************
        CALL gmonit(1,idyfs+23,averwt,errela,evtot)
        xsbt02   = xcrude*averwt
        erbt02   = xsbt02*errela
        WRITE(nout,bxl2f) xsbt02,erbt02,'xsec(beta02)  ','O(alf2)','b10'
*****************************************************************
        CALL gmonit(1,idyfs+24,averwt,errela,evtot)
        xsbt11   = xcrude*averwt
        erbt11   = xsbt11*errela
        WRITE(nout,bxl2f) xsbt11,erbt11,'xsec(beta11)  ','O(alf2)','b11'
*****************************************************************
        CALL gmonit(1,idyfs+25,averwt,errela,evtot)
        xsbt20   = xcrude*averwt
        erbt20   = xsbt20*errela
        WRITE(nout,bxl2f) xsbt20,erbt20,'xsec(beta20)  ','O(alf2)','b12'
*****************************************************************
*****************************************************************
        CALL gmonit(1,idyfs+26,averwt,errela,evtot)
        xsbt03   = xcrude*averwt
        erbt03   = xsbt20*errela
        WRITE(nout,bxl2f) xsbt03,erbt03,'xsec(beta03)  ','O(alf3)','b13'
*****************************************************************
        CALL gmonit(1,idyfs+27,averwt,errela,evtot)
        xsbt12   = xcrude*averwt
        erbt12   = xsbt20*errela
        WRITE(nout,bxl2f) xsbt12,erbt12,'xsec(beta12)  ','O(alf3)','b14'
*****************************************************************
        CALL gmonit(1,idyfs+28,averwt,errela,evtot)
        xsbt21   = xcrude*averwt
        erbt21   = xsbt20*errela
        WRITE(nout,bxl2f) xsbt21,erbt21,'xsec(beta21)  ','O(alf3)','b15'
*****************************************************************
        CALL gmonit(1,idyfs+29,averwt,errela,evtot)
        xsbt30   = xcrude*averwt
        erbt30   = xsbt20*errela
        WRITE(nout,bxl2f) xsbt30,erbt30,'xsec(beta30)  ','O(alf3)','b16'
*****************************************************************
        WRITE(nout,bxtxt) ' xsec_tot differences '
*****************************************************************
        CALL gmonit(1,idyfs+30,averwt,errela,evtot)
        xsdel1   = xcrude*averwt
        erdel1   = xsdel1*errela
        CALL gmonit(1,idyfs+31,averwt,errela,evtot)
        xsdel2   = xcrude*averwt
        erdel2   = xsdel2*errela
        CALL gmonit(1,idyfs+32,averwt,errela,evtot)
        xsdel3   = xcrude*averwt
        erdel3   = xsdel3*errela
        WRITE(nout,bxl2f) xsdel1,erdel1,'xstot(alf1-0)','O(alf1)','b17'
        WRITE(nout,bxl2f) xsdel2,erdel2,'xstot(alf2-1)','O(alf2)','b18'
        WRITE(nout,bxl2f) xsdel3,erdel3,'xstot(alf3-2)','O(alf3)','b19'
*****************************************************************
        WRITE(nout,bxtxt) ' betas differences '
*****************************************************************
        CALL gmonit(1,idyfs+33,averwt,errela,evtot)
        xsdt01   = xcrude*averwt
        erdt01   = xsdt01*errela
        WRITE(nout,bxl2f) xsdt01,erdt01,'xs(beta01-00)','O(alf1)','b20'
        WRITE(nout,bxl2f) xsbt10,erbt10,'xs(beta10)   ','O(alf1)','b21'
*****************************************************************
        CALL gmonit(1,idyfs+34,averwt,errela,evtot)
        xsdt02   = xcrude*averwt
        erdt02   = xsdt02*errela
        CALL gmonit(1,idyfs+35,averwt,errela,evtot)
        xsdt11   = xcrude*averwt
        erdt11   = xsdt11*errela
        WRITE(nout,bxl2f) xsdt02,erdt02,'xs(beta02-01)','O(alf2)','b19'
        WRITE(nout,bxl2f) xsdt11,erdt11,'xs(beta11-10)','O(alf2)','b20'
        WRITE(nout,bxl2f) xsbt20,erbt20,'xs(beta20)   ','O(alf2)','b21'
*****************************************************************
        CALL gmonit(1,idyfs+36,averwt,errela,evtot)
        xsdt03   = xcrude*averwt
        erdt03   = xsdt03*errela
        CALL gmonit(1,idyfs+37,averwt,errela,evtot)
        xsdt12   = xcrude*averwt
        erdt12   = xsdt12*errela
        CALL gmonit(1,idyfs+38,averwt,errela,evtot)
        xsdt21   = xcrude*averwt
        erdt21   = xsdt21*errela
        WRITE(nout,bxl2f) xsdt03,erdt03,'xs(beta03-02)','O(alf3)','b22'
        WRITE(nout,bxl2f) xsdt12,erdt12,'xs(beta12-11)','O(alf3)','b23'
        WRITE(nout,bxl2f) xsdt21,erdt21,'xs(beta21-20)','O(alf3)','b24'
        WRITE(nout,bxl2f) xsbt30,erbt30,'xs(beta30)   ','O(alf3)','b25'
*****************************************************************
        WRITE(nout,bxclo)
      ENDIF
      END

      SUBROUTINE f4_tests(mode,idyfs,xcrude,wttot,wtboww,wtbo4f,wt4f)
!     ***************************************************************
! 4fermion related tests
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / matpar / pi,ceuler
      COMMON / phypar / alfinv,gpicob
 
      COMMON / bxfmts / bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g
      CHARACTER*80      bxope,bxclo,bxtxt,bxl1i,bxl1f,bxl2f,bxl1g,bxl2g

      COMMON / inout  / ninp,nout

      DIMENSION wt4f(*)

      IF(mode .EQ. -1) THEN
*-- all 4-fermion
        DO k=91,96
          CALL gmonit(-1,idyfs+k,0d0,1d0,1d0) ! 91-96
        ENDDO
      ELSEIF(mode .EQ. 0) THEN
*-- 4-fermion monitoring
         IF (ABS(wtbo4f).GT.1d-50) THEN
           wttww = wtboww/wtbo4f*wttot
         ELSE
           wttww = 0d0
         ENDIF
         CALL gmonit(0,idyfs+91,wtbo4f,1d0,0d0)
         CALL gmonit(0,idyfs+92,wttot,1d0,0d0)
         CALL gmonit(0,idyfs+93,wttww,1d0,0d0)
         CALL gmonit(0,idyfs+94,wt4f(1),1d0,0d0)
         CALL gmonit(0,idyfs+95,wt4f(2),1d0,0d0)
         CALL gmonit(0,idyfs+96,wttot-wttww,1d0,0d0)
*-- END 4-fermion monitoring
      ELSEIF(mode .EQ. 1) THEN
*-- 4-fermion monitoring
        WRITE(nout,bxope)
        WRITE(nout,bxtxt) '         KORALW  final  report '
        WRITE(nout,bxtxt) '               Window D        '
        WRITE(nout,bxtxt) '                               '
        WRITE(nout,bxtxt) '     Complete 4-fermion process'
        WRITE(nout,bxtxt) '                               '
        WRITE(nout,bxtxt) '   I. Best ord. W-pair total xsect.    '
*****************************************************************
        CALL gmonit(1,idyfs+93,averwt,errela,evtot)
        WRITE(nout,bxl2g)
     $           averwt,errela,      '<wttww>: WW weight ','averwt','d1'
        xskbs   = xcrude*averwt
        erkbs   = xskbs*errela
        WRITE(nout,bxl2g)xskbs,erkbs,'sigma_WW, best [pb]','xskabo','d2'
        WRITE(nout,bxtxt) '                               '
        WRITE(nout,bxtxt) '   II. Best ord. 4-fermion total xsect.'
*****************************************************************
        CALL gmonit(1,idyfs+91,averwt,errela,evtot)
        WRITE(nout,bxl2g)
     $          averwt,errela,       '<wtbo4f>, rel err  ','averwt','d3'
*****************************************************************
        CALL gmonit(1,idyfs+92,averwt,errela,evtot)
        WRITE(nout,bxl2g)
     $          averwt,errela,       '<wttot>,rel err    ','averwt','d4'
        xskbb   = xcrude*averwt
        erkbb   = xskbb*errela
        WRITE(nout,bxl2g)xskbb,erkbb,'sigma_4f, best [pb]','xskabo','d5'
        stob = 1- xskbs/xskbb
        stober = dsqrt( (erkbs*xskbb)**2 +(erkbb*xskbs)**2 ) / xskbb**2
        WRITE(nout,bxl2g)stob,stober,'sigma 1-Wpair/4ferm','1-d2/5','d6'
*****************************************************************
        CALL gmonit(1,idyfs+96,averwt,errela,evtot)
        xskbd   = xcrude*averwt
        erkbd   = xskbd*errela
        stob = xskbd/xskbb
        stober = dsqrt( (erkbd*xskbb)**2 +(erkbb*xskbd)**2 ) / xskbb**2
        WRITE(nout,bxl2g)stob,stober,'sigma 1-Wpair/4ferm','wtbgr ','d7'
        WRITE(nout,bxclo)
      ENDIF
*****************************************************************
      END


      SUBROUTINE NAIVE_QCD(label,br,wt_qcd)
!******************************************
! This routine adds the naive QCD correction to the external matrix el.
! It is done only for the WW final states, and is justified for CC03.
! Also the effective nontrivial CKM is introduced on request.
! Everything is done based solely on the deviation of branching ratios
! from the 1/3, 1/9 settings.

      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      DIMENSION br(20),br0(20)
      DATA init /0/
      SAVE
 
      IF(init .EQ. 0) THEN
         init=1

         br0(1)=(1d0/3d0) !  <== ud
         br0(2)=0d0       !  <== cd
         br0(3)=0d0       !  <== us
         br0(4)=(1d0/3d0) !  <== cs
         br0(5)=0d0       !  <== ub
         br0(6)=0d0       !  <== cb
         br0(7)=(1d0/9d0) !  <== e
         br0(8)=(1d0/9d0) !  <== mu
         br0(9)=(1d0/9d0) !  <== tau
      ENDIF
! do not redefine off-diagonal states, they are corrected already in
! Born
! off-diagonal are also SINGLE off-diag.  m.s. 3/13/98
         
      CALL linear_to_WZ_label(1,label,iwm,iwp,if_z,if_w)
      IF( if_w .NE. 0 ) THEN
         IF(br0(iwm) .NE. 0d0 .AND. br0(iwp) .NE. 0d0) THEN
           wm = (br(iwm)/br(7)) / (br0(iwm)/br0(7))
           wp = (br(iwp)/br(7)) / (br0(iwp)/br0(7))
         ELSE
           wm = 1d0
           wp = 1d0
         ENDIF
         wt_q= wm*wp
      ELSE
         wt_q=1d0
      ENDIF
           
      wt_qcd=wt_q
          
      END
