{
//============================================================================
// .x Merge.C
//============================================================================
gROOT->Reset();
c1 = new TCanvas("c1","c1",800,200);
c1->Draw();
//============================================================================
char *cfiles[] = {
        "farm/1/rmain.root",
	"farm/2/rmain.root",
	"farm/3/rmain.root",
	""};
//============================================================================
TFile *fnew = new TFile("rmain.root","RECREATE");
//============================================================================
TList *flist = new TList();
//============================================================================
TFile *afile, *file1;
Int_t nfiles = 0;
while (strlen(cfiles[nfiles])) 
{
  printf("file= %s\n",cfiles[nfiles]);
  afile = new TFile(cfiles[nfiles]);
  flist->Add(afile);
  nfiles++;
}
//============================================================================
TH1     *h1,*h2;
TTree   *t1,*t2;
TNtuple *n1,*n2;
TObject *obj;
TKey    *key;
//============================================================================
afile = file1 = (TFile*)flist->First();
//============================================================================
TIter nextkey(file1->GetListOfKeys());
//============================================================================
while (key = (TKey*)nextkey())
{
  file1->cd();
  obj = key->Read();
  if(obj->IsA()->InheritsFrom("TH1"))
    {
      // This part for histograms works fine
      printf("this obj.= %s, title = %s \n",obj->GetName(),obj->GetTitle());
      h1 = (TH1*)obj;
      afile = (TFile*)flist->After(file1);
      while (afile)
	{
	  //printf("  another afile \n");
	  h2 = (TH1*)afile->Get(h1->GetName());
	  if(h2) h1->Add(h2);
	  afile = (TFile*)flist->After(afile);
	}
      fnew->cd(); obj->Write(key->GetName());
    }
  else if( TString(obj->GetName()) == "jtuple")
    {
      // This part is a TEMPORARY BRICOLAGE!!!!
      //(((((((((((((((((((
      printf("special file= %s, title = %s \n",obj->GetName(),obj->GetTitle());
      n1 = (TNtuple*)obj;
      //n1->Inspect();
      pulapka = new TH1F("pulapka","pulapka", 20,0,20);
      float raw[30];

      afile = (TFile*)flist->After(file1);
      while (afile)
	{
	  printf("  ANOTHER AFILE \n");
	  n2 = (TNtuple*)afile->Get(n1->GetName());
	  int nent = n2->GetEntries(); printf("nent= %i\n",nent);
	  for( int iev=0; iev< nent; iev++)
	    {
	  //"m0:m1:m2:m3:m4:m5:x0:x1:x2:x3:x4:x5:np:nj:wt:wt2:pan:jan:pen:jen"
	      n2->Draw( "0.5>>pulapka","m0","goff",1,iev);
	      n2->Draw("1.5>>+pulapka","m1","goff",1,iev);
	      n2->Draw("2.5>>+pulapka","m2","goff",1,iev);
	      n2->Draw("3.5>>+pulapka","m3","goff",1,iev);
	      n2->Draw("4.5>>+pulapka","m4","goff",1,iev);
	      n2->Draw("5.5>>+pulapka","m5","goff",1,iev);
	      n2->Draw("6.5>>+pulapka","x0","goff",1,iev);
	      n2->Draw("7.5>>+pulapka","x1","goff",1,iev);
	      n2->Draw("8.5>>+pulapka","x2","goff",1,iev);
	      n2->Draw("9.5>>+pulapka","x3","goff",1,iev);
	      n2->Draw("10.5>>+pulapka","x4","goff",1,iev);
	      n2->Draw("11.5>>+pulapka","x5","goff",1,iev);
	      n2->Draw("12.5>>+pulapka","np","goff",1,iev);
	      n2->Draw("13.5>>+pulapka","nj","goff",1,iev);
	      n2->Draw("14.5>>+pulapka","wt","goff",1,iev);
	      n2->Draw("15.5>>+pulapka","wt2","goff",1,iev);
	      n2->Draw("16.5>>+pulapka","pan","goff",1,iev);
	      n2->Draw("17.5>>+pulapka","jan","goff",1,iev);
	      n2->Draw("18.5>>+pulapka","pen","goff",1,iev);
	      n2->Draw("19.5>>+pulapka","jen","goff",1,iev);
	      for (int k=0; k<20;k++) 
		{
		  raw[k] = pulapka->GetBinContent(k+1);
		  //printf(" %f",raw[k]);
		}
	      //printf(" %s \n\n","");
	      n1->Fill(raw);
	    } // for iev
	  afile = (TFile*)flist->After(afile);
	}
      delete pulapka;
      fnew->cd(); obj->Write(key->GetName());
      //))))))))))))))))))
    }
  else if(obj->IsA()->InheritsFrom("TTree"))
    {
      //[[[[[[[[[[[[[[
      // this part is still not properly implemented !!!!!
      // ntuples are not combined, only one of them gets through
      printf("THIS OBJ.= %s, title = %s \n",obj->GetName(),obj->GetTitle());
      t1 = (TTree*)obj;
      afile = (TFile*)flist->After(file1);
      while (afile)
	{
	  printf("  ANOTHER AFILE \n");
	  t2 = (TTree*)afile->Get(t1->GetName());
	  //if(t2) t1->Add(t2);
	  //if(t2) printf(" got it \n");
	  afile = (TFile*)flist->After(afile);
	}
      fnew->cd(); obj->Write(key->GetName());
      //]]]]]]]]]]]]]]]
    }
  else
    {     
      printf("ignored obj.= %s, title = %s \n",obj->GetName(),obj->GetTitle());
    }
  //fnew->cd();
  //obj->Write(key->GetName());
  delete obj;
}
//============================================================================
fnew->cd();
fnew->ls();
fnew->Write();
//delete fnew;
flist->Delete();
delete flist;
//============================================================================
//============================================================================
//============================================================================
}
