{
// .x view-BEdis.C
// 2W counterterm i.e. wt (not wt2 !!!)
// distr. of clusters, 2 and 3 pion BE effect
//
gROOT->Reset();
//------------------------------------------------------------------------
gStyle->SetFrameLineWidth(3);
gStyle->SetStatX(-5.0);
gStyle->SetStatColor(0);
gStyle->SetTitleColor(0);
gStyle->SetTitleW(0.70);
gStyle->SetTitleH(0.09);
gStyle->SetTitleX(0.03);
gStyle->SetTitleY(1.00);
//
TPaveText labelGEV( .35,.11, .35+.40,.11+.10, "NDC");
labelGEV.AddText("Q^2! [GeV^2!]");
labelGEV.SetFillColor(10);
labelGEV.SetBorderSize(0);
//
//------------------------------------------------------------------------
cBEdis = new TCanvas("cBEdis","The Ntuple canvas",800,800);
//------------------------------------------------------------------------
// mode=1 is for ploting BE distributions from ntuples
// mode=0 from histograms, this requires counterterm during generation
#define MODE 0
//------------------------------------------------------------------------
// 172GeV production
//TFile f1("../run/172GeV.2J/rmain.root.40k"); !!!! to be implemented !!!
//
TFile f1("../run/172GeV.4J/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root.160k");
Text_t *WT=    "(wt*exp(-np*log(1.0)))/1.0";
//------------------------------------------------------------------------
// 172GeV test
//TFile f1("../run/rmain.root.172GeV.4J.5k");
//Text_t *WT=    "(wt*exp(-np*log(1.0675)))/0.1751";
//------------------------------------------------------------------------
//                 (a)
//------------------------------------------------------------------------
cBEdis.cd();
cBEdis.SetFillColor(5);
TPad pad1("pad1","This is pad1", .00,.50,.50,1.00);
pad1.Draw();
pad1.cd();
pad1.SetFillColor(10);
// pairs  wt=1
#if (MODE == 1)
TH1F *hst_unQ2 = new TH1F("hst_unQ2" ,"Q2 pairs  ",100,0,1);
ctuple2.Draw("Q>>hst_unQ2","","goff");
#endif
hst_unQ2.SetTitle("(a) Q^2!: 2 pions");
hst_unQ2->SetLabelSize(0.05,"X");
hst_unQ2->SetLabelSize(0.03,"Y");
hst_unQ2.Draw();
labelGEV.Draw();
//
cBEdis.Update();
//
//------------------------------------------------------------------------
//                 (c)
//------------------------------------------------------------------------
cBEdis.cd();
TPad pad2("pad2","This is pad2", .50,.50,1.00,1.00);
pad2.Draw();
pad2.cd();
pad2.SetFillColor(10);
// pairs  wted and ratio
#if (MODE == 1)
TH1F *hst_wtQ2 = new TH1F("hst_wtQ2" ,"Q2 pairs  ",100,0,1);
ctuple2.Draw("Q>>hst_wtQ2",WT,"goff");
#endif
// here is some mess !!!!!
//((((( This substitution is a trick to avoid apparent bug in ROOT
TH1F *hst_dum1 = *hst_unQ2;
hst_wtQ2.Divide(hst_dum1);
//)))))
//[[[[[ ??? this direct division crashes
//hst_wtQ2->Divide(hst_unQ2);
//TH1F *hst_dum1 = (hst_wtQ2)/(hst_unQ2);
//]]]]] ???
hst_wtQ2.SetTitle("(c) B.E. effect 2 pi");
hst_wtQ2->SetLabelSize(0.05);
hst_wtQ2.Draw();
labelGEV.Draw();
//
cBEdis.Update();
//------------------------------------------------------------------------
//                 (b)
//------------------------------------------------------------------------
cBEdis.cd();
TPad pad3("pad3","This is pad3", .00,.00,.50,.50);
pad3.Draw();
pad3.cd();
pad3.SetFillColor(10);
// triplets  wt=1
#if (MODE == 1)
TH1F *hst_unQ3 = new TH1F("hst_unQ3" ,"Q2 triplets",100,0,1);
ctuple3.Draw("Q>>hst_unQ3","","goff");
#endif
//hst_unQ3.Draw();
//-- cluster multipl
hst_nclu.SetTitle("(b) cluster multiplicity");
hst_nclu->SetLabelSize(0.05,"X");
hst_nclu->SetLabelSize(0.03,"Y");
hst_nclu.Draw();
cBEdis.Update();
//
//------------------------------------------------------------------------
//                 (d)
//------------------------------------------------------------------------
cBEdis.cd();
TPad pad4("pad4","This is pad4", .50,.00,1.00,.50);
pad4.Draw();
pad4.cd();
pad4.SetFillColor(10);
//
// pairs  wted and ratio
#if (MODE == 1)
TH1F *hst_wtQ3 = new TH1F("hst_wtQ3" ,"Q2 triplets  ",100,0,1);
ctuple3.Draw("Q>>hst_wtQ3",WT,"goff");
#endif
hst_unQ3->Draw(); // <-another trick!!!
// This substitution is a trick to avoid apparent bug in ROOT
TH1F *hst_dum2 = *hst_unQ3;
hst_wtQ3.Divide(hst_dum2);
//hst_wtQ3.Divide(hst_unQ3);
hst_wtQ3.SetTitle("(d) B.E. effect 3 pi");
hst_wtQ3->SetLabelSize(0.05);
hst_wtQ3.Draw();
labelGEV.Draw();
//
cBEdis.Update();
cBEdis.cd();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
}
