{
//
// In this exercise we project of diagonal i.e. we take (m0+m1)/2
// .x view-par3.C
//
gROOT.Reset();
gStyle->SetOptStat(0);   // to get rid of statistics!!!
gStyle->SetOptTitle(0);  // to get rid of title!!!
//
TPaveLabel  labelGeV( .70, .01, .70+.15, .01+.08, "[GeV]","NDC");
labelGeV.SetBorderSize(0);
labelGeV.SetFillColor(0);
TPaveLabel  labelA(.00,.92,1.0,1.0,"(a) QUARK mass avg.","NDC");
labelA.SetBorderSize(0);
labelA.SetFillColor(0);
TPaveLabel  labelB(.00,.92,1.0,1.0,"(b) QUARK mass avg with CUT","NDC");
labelB.SetBorderSize(0);
labelB.SetFillColor(0);
TPaveLabel  labelC(.00,.92,1.0,1.0,"(c) JET mass avg.","NDC");
labelC.SetBorderSize(0);
labelC.SetFillColor(0);
TPaveLabel  labelD(.00,.92,1.0,1.0,"(d) JET mass avg with CUT","NDC");
labelD.SetBorderSize(0);
labelD.SetFillColor(0);
//------------------------------------------------------------------------
cPar3 = new TCanvas("cPar3","The Ntuple canvas",800,800);
cPar3->SetFillColor(0);
//
// Connect ROOT histogram/ntuple demonstration file
//TFile f1("../run/172GeV.4J.mini/rmain.root");
TFile f1("../run/172GeV.4J/rmain.root");
//TFile f1("../run/172GeV.4J/rmain.root.160k");
//TFile f1("../run/172GeV.4J/rmain.root");
//
//------------------------------------------------------------------------
jtuple.SetFillStyle(1001);
jtuple.SetFillColor(24);
//------------------------------------------------------------------------
cPar3.cd();
TPad pad3("pad3","This is pad3", .00,.50, .50,1.00, 5, 0, 0);
pad3.SetFillColor(0);
pad3.SetBorderSize(0);
pad3.Draw();
pad3.cd();
//
mass_res = new TH1F("mass_res","mass resonant",100, 70,90);
jtuple.Draw("0.5*(m0+m1)>>mass_res","","");
//
mass_all = new TH1F("mass_all","(a) QUARK mass avg.", 100,70,90);
jtuple.Draw("0.5*(m4+m5)>>mass_all" ,"","goff");
jtuple.Draw("0.5*(m2+m3)>>+mass_all","","goff");
jtuple.Draw("0.5*(m0+m1)>>+mass_all","","goff");
mass_all->SetLabelSize(0.06);
//
mass_combi = new TH1F("mass_combi","mass combinatorial", 100,70,90);
mass_combi.Add(mass_all,mass_res, 1. , -1.);
//(*mass_combi) = (*mass_all) - (*mass_res);
mass_combi->SetLineColor(2);
//
mass_all->Draw();
mass_combi->Draw("same");
labelGeV.Draw();
labelA.Draw();
cPar3.Update();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cPar3.cd();
TPad pad4("pad4","This is pad4", .50,.50,1.00,1.00, 5, 0, 0);
pad4.SetFillColor(0);
pad4.Draw();
pad4.cd();
//
mass_res_cut = new TH1F("mass_res_cut","mass resonant cut",100, 70,90);
jtuple.Draw("0.5*(m0+m1)>>mass_res_cut","abs(m0-m1)<5.0","");
//
mass_all_cut=new TH1F("mass_all_cut","(b) QUARK mass avg with CUT", 100,70,90);
jtuple.Draw("0.5*(m4+m5)>>mass_all_cut" ,"abs(m4-m5)<5.0","goff");
jtuple.Draw("0.5*(m2+m3)>>+mass_all_cut","abs(m2-m3)<5.0","goff");
jtuple.Draw("0.5*(m0+m1)>>+mass_all_cut","abs(m0-m1)<5.0","goff");
mass_all_cut->SetLabelSize(0.06);
//
mass_combi_cut = new TH1F("mass_combi_cut","mass combinatorial ", 100,70,90);
mass_combi_cut.Add(mass_all_cut,mass_res_cut, 1. , -1.);
//(*mass_combi_cut) = (*mass_all_cut) - (*mass_res_cut);
mass_combi_cut->SetLineColor(2);
//
mass_all_cut->Draw();
mass_combi_cut->Draw("same");
labelGeV.Draw();
labelB.Draw();
cPar3.Update();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cPar3.cd();
TPad pad1("pad1","This is pad1", .00,.00, .50,.50, 5, 0, 0);
pad1.SetFillColor(0);
pad1.SetBorderSize(0);
pad1.Draw();
pad1.cd();
//
Jmass_all = new TH1F("Jmass_all","(c) JET mass avg.", 100,70,90);
jtuple.Draw("0.5*(x4+x5)>>Jmass_all" ,"","goff");
jtuple.Draw("0.5*(x2+x3)>>+Jmass_all","","goff");
jtuple.Draw("0.5*(x0+x1)>>+Jmass_all","","goff");
Jmass_all->SetLabelSize(0.06);
Jmass_all.Draw();
labelGeV.Draw();
labelC.Draw();
cPar3.Update();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cPar3.cd();
TPad pad2("pad2","This is pad2", .50,.00,1.00,.50, 5, 0, 0);
pad2.SetFillColor(0);
pad2.SetBorderSize(0);
pad2.Draw();
pad2.cd();
//
Jmass_all_cut=new TH1F("Jmass_all_cut","(d) JET mass avg with CUT", 100,70,90);
jtuple.Draw("0.5*(x4+x5)>>Jmass_all_cut" ,"abs(x4-x5)<10.0","goff");
jtuple.Draw("0.5*(x2+x3)>>+Jmass_all_cut","abs(x2-x3)<10.0","goff");
jtuple.Draw("0.5*(x0+x1)>>+Jmass_all_cut","abs(x0-x1)<10.0","goff");
Jmass_all_cut->SetLabelSize(0.06);
Jmass_all_cut.Draw();
labelGeV.Draw();
labelD.Draw();
cPar3.Update();
//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------
cPar3.cd();
//------------------------------------------------------------------------
}
